using System.Web.Mvc;
using System.Web.Routing;
using SportsStore.WebUI.Infrastructure;
using SportsStore.WebUI.Binders;
using SportsStore.Domain.Entities;

namespace SportsStore.WebUI
{
    
    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                null,
                "",                         //Only matches the empty URL (i.e. /)
                new { Controller = "Product", Action = "List", category = (string)null, page = 1}
            );

            routes.MapRoute(
                null,                       // don't need to specify a name
                "Page{page}",               // Matches /Page2, /Page123, but not /PageABC
                new { controller = "Product", action = "List", category = (string)null },
                new { page = @"\d+" }       // Constraints: page must be numerical
            );

            routes.MapRoute(
               null,
               "{category}",                // Matches /Football or /anything with no slash
               new { controller = "Product", action = "List", page = 1 }
           );

            routes.MapRoute(
                null,
                "{category}/Page{page}",    // Matches /Football/Page567
                new { controller = "Product", action = "List" },    
                new { page = @"\d+"}        //Contrains: page must be numerical
            );

            routes.MapRoute(
                null,
                "{controller}/{action}"
            );
        }

        protected void Application_Start()
        {
            AreaRegistration.RegisterAllAreas();

            RegisterGlobalFilters(GlobalFilters.Filters);
            RegisterRoutes(RouteTable.Routes);

            ControllerBuilder.Current.SetControllerFactory(new NinjectControllerFactory());
            ModelBinders.Binders.Add(typeof(Cart), new CartModelBinder());
        }
    }
}